
var doDump = true;
var tiddlysaveStatus;

window.addEventListener("load", onPageInit, false);

/*
 *  Initialization functions
 */
 
function onPageInit()
{
  var appcontent = document.getElementById("appcontent"); 
  tiddlysaveStatus = document.getElementById("tiddlysave-status");
  
  if(appcontent)
  {
  	appcontent.addEventListener("focus", checkTiddlyWiki, true);
  }
}

function checkTiddlyWiki(aEvent)
{	
	var doc = window._content.document;
	
	// We may have just left a TiddlyWiki, so reset appropriate elements
  	tiddlysaveStatus.style.visibility = "collapse";
	doc.onkeypress = null;
		
	if (doc.location && doc.location.protocol == "file:" 
		&& doc.doctype && doc.doctype.name.toUpperCase() == "HTML")
	{	
		tiddlyDump("Local HTML file identified");
		if (doc.getElementsByTagName("head")[0].childNodes[0].data.substring(1,15) == "TiddlyWiki 1.1")
		{
			tiddlyDump("TiddlyWiki 1.1 page identified");
			
			tiddlysaveStatus.style.visibility = "visible";
			window._content.ShowSource = ShowSource;
			window._content.onClickToolbarSave = onClickToolbarSave;
			doc.onkeypress = checkKeyPress;
		}
	}	
}

/*
 *  Document reading & output functions
 */

function performTiddlySave() 
{
	try
	{	
		window.status = "Saving TiddlyWiki...";
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
		var outputFile = fileHandler.getFileFromURLSpec(window._content.document.location.toString());

		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		outputStream.init(outputFile, 0x02 | 0x08 | 0x20, 0664, 0);

		var outputText = getDocumentText();
		
		outputStream.write(outputText, outputText.length);
		outputStream.close();
		tiddlyDump("TiddlyWiki written to "+outputFile.path);
		window.status = "TiddlyWiki saved to " + outputFile.path;
	}
	
	catch (e)
	{
		alert("Error occured when saving file.");
		tiddlyDump("\n"+e);
	}
	
	finally
	{
		setTimeout("window.status = \"\"", 3000);
	}
}

function getDocumentText()
{
	// This seems like such a hack...is there a better way?
	var theDoctype = window._content.document.doctype;

	var outputText = "<!DOCTYPE "+theDoctype.name+" PUBLIC \""+theDoctype.publicId+"\"";
	if (theDoctype.systemId != "")
		outputText += " \""+theDoctype.systemId+"\"";
	outputText += ">\n";

	outputText += "<html>"+window._content.document.documentElement.innerHTML+"</html>";
	
	return outputText;
}

/*
 *  Additional functionality
 */ 

function undoAllOpenEdits()
{
    var tiddlerDisplay = window._content.document.getElementById("tiddlerDisplay");
    for(var t=0;t<tiddlerDisplay.childNodes.length;t++)
    {
		window._content.displayTiddler(null, tiddlerDisplay.childNodes[t].id.substr(7), 1, null, null, false);
    }
}

/*
 *  Standard event listeners
 */

function checkKeyPress(e)
{
	if (nsPreferences.getBoolPref("tiddlysave.useCtrlS", true)
		&& (String.fromCharCode(e.which).toLowerCase() == "s")
		&& e.ctrlKey)
	{
		performTiddlySave();
		
		// Don't let anything else handle this keypress (namely the browser save function)
		return false;
	}
	/*
	else if (e.keyCode == 9)
	{
		
	}*/
	
	else if (e.keyCode == 27)
	{
		undoAllOpenEdits();
		return false;
		
	}
	
	return true;
}

/*
 *  TiddlyWiki function replacements
 */

// I haven't found a way to make this more elegant yet. 
// Reproduce the code on the page along with the call to performTiddlySave()

function onClickToolbarSave(e)
{
	if(this.parentNode.id) 
		window._content.saveTiddler(this.parentNode.id.substr(7)); 
		
	performTiddlySave();
}

function ShowSource()
{
	performTiddlySave();
}

/*
 * Misc. helper functions
 */

function tiddlyDump(str)
{
	if (doDump)
		dump("TiddlySave: "+str+"\n");
}


/*
 *  Old code to hang onto for the time being
 */

/*
function stealSaveButton()
{
	var anchors = window._content.document.getElementsByTagName("a");

	for (i=0; i<anchors.length; ++i)
	{
		// After we save once, the ShowSource call won't be there any longer,
		//   so we'll need to leave a nop that we can expect to be unique
		if (anchors[i].href == "javascript:ShowSource()"
		|| anchors[i].href == "javascript:;;;;;")
		{
			anchors[i].href = "javascript:;;;;;";
			anchors[i].onclick = performTiddlySave;
			tiddlysaveStatus.style.visibility = "visible";
			tiddlyDump("Added save listener.");
		}
	}
}
*/

/*
function addSaveEvent()
{
	
	document.addEventListener("SaveTiddlyWikiEvent", performTiddlySave, false);

		
	window._content.onClickToolbarSave = 
		new Function("if(this.parentNode.id) window._content.saveTiddler(this.parentNode.id.substr(7)); var ev = document.createEvent(\"Events\"); ev.initEvent(\"SaveTiddlyWikiEvent\", true, false);	this.dispatchEvent(ev);");
}
*/